//
// © 2005-2008 Marko Lindqvist
//

#include "sdksinput.h"


sdks_input::sdks_input(int size)
{
  int dimension = size*size;

  base_size = size;
  values = NULL;
  ready = true; // FIXME: Set only when input really ready
  illegal = false;

  values = new int*[dimension];

  for (int i = 0; i < dimension; i++) {
    values[i] = new int[dimension];
  }
}

sdks_input::~sdks_input()
{
  free_mem();
}

void sdks_input::free_mem()
{
  int dimension = base_size*base_size;

  for (int i = 0; i < dimension; i++) {
    delete [] values[i];
  }

  delete [] values;
  values = NULL;
}

int sdks_input::get_size()
{
  return base_size;
}

void sdks_input::set_value(int x, int y, int value)
{
  values[y][x] = value;
}

int sdks_input::get_value(int x, int y)
{
  return values[y][x];
}

bool sdks_input::is_ok()
{
  return ready && !illegal;
}

void sdks_input::set_fail()
{
  illegal = true;
}
